/* $XFree86: xc/include/extensions/xtrapproto.h,v 1.1 2001/11/02 23:29:26 dawes Exp $ */

#ifndef __XTRAPPROTO__
#define __XTRAPPROTO__
/* RCSID = $Header$" */

/*****************************************************************************
Copyright 1987, 1988, 1989, 1990, 1991 by Digital Equipment Corp., Maynard, MA

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of Digital not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

*****************************************************************************/
/*
 *
 *  CONTRIBUTORS:
 *
 *      Dick Annicchiarico
 *      Robert Chesler
 *      Dan Coutu
 *      Gene Durso
 *      Marc Evans
 *      Alan Jamison
 *      Mark Henry
 *      Ken Miller
 *
 *  DESCRIPTION:
 *      This header file contains the function prototypes for extension
 *      routines sorted by module (globally defined routines *only*).
 */
#ifndef Bool
# define Bool int
#endif
/* xtrapdi.c */
XLIBEXPORT int XETrapDestroyEnv (pointer value , XID id );
XLIBEXPORT void XETrapCloseDown ( ExtensionEntry *extEntry );
XLIBEXPORT Bool XETrapRedirectDevices (void );
XLIBEXPORT void DEC_XTRAPInit (void );
XLIBEXPORT int XETrapCreateEnv (ClientPtr client );
XLIBEXPORT int XETrapDispatch (ClientPtr client );
XLIBEXPORT int sXETrapDispatch (ClientPtr client );
XLIBEXPORT int XETrapReset (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapGetAvailable (xXTrapGetReq *request , ClientPtr client );
XLIBEXPORT int XETrapGetCurrent (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapGetStatistics (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapConfig (xXTrapConfigReq *request , ClientPtr client );
XLIBEXPORT int XETrapStartTrap (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapStopTrap (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapGetVersion (xXTrapGetReq *request , ClientPtr client );
XLIBEXPORT int XETrapGetLastInpTime (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int XETrapRequestVector (ClientPtr client );
XLIBEXPORT int XETrapKeyboard (xEvent *x_event , DevicePtr keybd , int count );
#ifndef VECTORED_EVENTS
XLIBEXPORT int XETrapPointer (xEvent *x_event , DevicePtr ptrdev , int count );
#else
XLIBEXPORT int XETrapEventVector (ClientPtr client , xEvent *x_event );
#endif
XLIBEXPORT void XETrapStampAndMail (xEvent *x_event );
XLIBEXPORT void sReplyXTrapDispatch (ClientPtr client , int size , char *reply );
XLIBEXPORT int XETrapWriteXLib (XETrapEnv *penv , BYTE *data , CARD32 nbytes );
XLIBEXPORT 
/* xtrapddmi.c */
XLIBEXPORT void XETrapPlatformSetup (void );
XLIBEXPORT int XETrapSimulateXEvent (xXTrapInputReq *request , ClientPtr client );

/* xtrapdiswap.c */
XLIBEXPORT int sXETrapReset (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int sXETrapGetAvailable (xXTrapGetReq *request , ClientPtr client );
XLIBEXPORT int sXETrapConfig (xXTrapConfigReq *request , ClientPtr client );
XLIBEXPORT int sXETrapStartTrap (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int sXETrapStopTrap (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int sXETrapGetCurrent (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int sXETrapGetStatistics (xXTrapReq *request , ClientPtr client );
XLIBEXPORT int sXETrapSimulateXEvent (xXTrapInputReq *request , ClientPtr client );
XLIBEXPORT int sXETrapGetVersion (xXTrapGetReq *request , ClientPtr client );
XLIBEXPORT int sXETrapGetLastInpTime (xXTrapReq *request , ClientPtr client );
XLIBEXPORT void sReplyXETrapGetAvail (ClientPtr client , int size , char *reply );
XLIBEXPORT void sReplyXETrapGetVers (ClientPtr client , int size , char *reply );
XLIBEXPORT void sReplyXETrapGetLITim (ClientPtr client , int size , char *reply );
XLIBEXPORT void sReplyXETrapGetCur (ClientPtr client , int size , char *reply );
XLIBEXPORT void sReplyXETrapGetStats (ClientPtr client , int size , char *reply );
XLIBEXPORT void sXETrapHeader (XETrapHeader *hdr );
XLIBEXPORT void XETSwSimpleReq (xReq *data );
XLIBEXPORT void XETSwResourceReq (xResourceReq *data );
XLIBEXPORT void XETSwCreateWindow (xCreateWindowReq *data , ClientPtr client );
XLIBEXPORT void XETSwChangeWindowAttributes (xChangeWindowAttributesReq *data , ClientPtr client );
XLIBEXPORT void XETSwReparentWindow (xReparentWindowReq *data );
XLIBEXPORT void XETSwConfigureWindow (xConfigureWindowReq *data  , ClientPtr client );
XLIBEXPORT void XETSwInternAtom (xInternAtomReq *data );
XLIBEXPORT void XETSwChangeProperty (xChangePropertyReq *data );
XLIBEXPORT void XETSwDeleteProperty (xDeletePropertyReq *data );
XLIBEXPORT void XETSwGetProperty (xGetPropertyReq *data );
XLIBEXPORT void XETSwSetSelectionOwner (xSetSelectionOwnerReq *data );
XLIBEXPORT void XETSwConvertSelection (xConvertSelectionReq *data );
XLIBEXPORT void XETSwSendEvent (xSendEventReq *data );
XLIBEXPORT void XETSwGrabPointer (xGrabPointerReq *data );
XLIBEXPORT void XETSwGrabButton (xGrabButtonReq *data );
XLIBEXPORT void XETSwUngrabButton (xUngrabButtonReq *data );
XLIBEXPORT void XETSwChangeActivePointerGrab (xChangeActivePointerGrabReq *data );
XLIBEXPORT void XETSwGrabKeyboard (xGrabKeyboardReq *data );
XLIBEXPORT void XETSwGrabKey (xGrabKeyReq *data );
XLIBEXPORT void XETSwUngrabKey (xUngrabKeyReq *data );
XLIBEXPORT void XETSwGetMotionEvents (xGetMotionEventsReq *data );
XLIBEXPORT void XETSwTranslateCoords (xTranslateCoordsReq *data );
XLIBEXPORT void XETSwWarpPointer (xWarpPointerReq *data );
XLIBEXPORT void XETSwSetInputFocus (xSetInputFocusReq *data );
XLIBEXPORT void XETSwOpenFont (xOpenFontReq *data );
XLIBEXPORT void XETSwListFonts (xListFontsReq *data );
XLIBEXPORT void XETSwListFontsWithInfo (xListFontsWithInfoReq *data );
XLIBEXPORT void XETSwSetFontPath (xSetFontPathReq *data );
XLIBEXPORT void XETSwCreatePixmap (xCreatePixmapReq *data );
XLIBEXPORT void XETSwCreateGC (xCreateGCReq *data , ClientPtr client );
XLIBEXPORT void XETSwChangeGC (xChangeGCReq *data , ClientPtr client );
XLIBEXPORT void XETSwCopyGC (xCopyGCReq *data );
XLIBEXPORT void XETSwSetDashes (xSetDashesReq *data );
XLIBEXPORT void XETSwSetClipRectangles (xSetClipRectanglesReq *data , ClientPtr client );
XLIBEXPORT void XETSwClearToBackground (xClearAreaReq *data );
XLIBEXPORT void XETSwCopyArea (xCopyAreaReq *data );
XLIBEXPORT void XETSwCopyPlane (xCopyPlaneReq *data );
XLIBEXPORT void XETSwPoly (xPolyPointReq *data , ClientPtr client );
XLIBEXPORT void XETSwFillPoly (xFillPolyReq *data , ClientPtr client );
XLIBEXPORT void XETSwPutImage (xPutImageReq *data );
XLIBEXPORT void XETSwGetImage (xGetImageReq *data );
XLIBEXPORT void XETSwPolyText (xPolyTextReq *data );
XLIBEXPORT void XETSwImageText (xImageTextReq *data );
XLIBEXPORT void XETSwCreateColormap (xCreateColormapReq *data );
XLIBEXPORT void XETSwCopyColormapAndFree (xCopyColormapAndFreeReq *data );
XLIBEXPORT void XETSwAllocColor (xAllocColorReq *data );
XLIBEXPORT void XETSwAllocNamedColor (xAllocNamedColorReq *data );
XLIBEXPORT void XETSwAllocColorCells (xAllocColorCellsReq *data );
XLIBEXPORT void XETSwAllocColorPlanes (xAllocColorPlanesReq *data );
XLIBEXPORT void XETSwFreeColors (xFreeColorsReq *data , ClientPtr client );
XLIBEXPORT void XETSwStoreColors (xStoreColorsReq *data , ClientPtr client );
XLIBEXPORT void XETSwStoreNamedColor (xStoreNamedColorReq *data );
XLIBEXPORT void XETSwQueryColors (xQueryColorsReq *data , ClientPtr client );
XLIBEXPORT void XETSwLookupColor (xLookupColorReq *data );
XLIBEXPORT void XETSwCreateCursor (xCreateCursorReq *data );
XLIBEXPORT void XETSwCreateGlyphCursor (xCreateGlyphCursorReq *data );
XLIBEXPORT void XETSwRecolorCursor (xRecolorCursorReq *data );
XLIBEXPORT void XETSwQueryBestSize (xQueryBestSizeReq *data );
XLIBEXPORT void XETSwQueryExtension (xQueryExtensionReq *data );
XLIBEXPORT void XETSwChangeKeyboardMapping (xChangeKeyboardMappingReq *data );
XLIBEXPORT void XETSwChangeKeyboardControl (xChangeKeyboardControlReq *data , ClientPtr client );
XLIBEXPORT void XETSwChangePointerControl (xChangePointerControlReq *data );
XLIBEXPORT void XETSwSetScreenSaver (xSetScreenSaverReq *data );
XLIBEXPORT void XETSwChangeHosts (xChangeHostsReq *data );
XLIBEXPORT void XETSwRotateProperties (xRotatePropertiesReq *data , ClientPtr client );
XLIBEXPORT void XETSwNoOperation (xReq *data );
#ifdef vms
XLIBEXPORT void SwapLongs (long *list , unsigned long count );
XLIBEXPORT void SwapShorts (short *list , unsigned long count );
XLIBEXPORT int SwapColorItem (xColorItem *pItem );
#endif /* vms */


#endif /* __XTRAPPROTO__ */
