/**
 * \file mi32/textresitemlist.h
 * \brief TEXTRESITEMLIST class definition
 *
 * \if NODOC
 * $Id: textresitemlist.h_v 1.1 2006/10/06 17:39:54 mju Exp $
 *
 * $Log: textresitemlist.h_v $
 * Revision 1.1  2006/10/06 17:39:54  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_TEXTRESITEMLIST_H
#define	INC_MI32_TEXTRESITEMLIST_H

#ifndef	INC_MI32_TEXTRESITEM_H
	#include <mi32/textresitem.h>
#endif

#ifndef	INC_MI32_MILIST_H
	#include <mi32/milist.h>
#endif

#ifdef MISYSTEMDLL
	#define CLASSLIBEXPORT MI_DLLCLASSEXPORT
#else
	#define CLASSLIBEXPORT MI_DLLCLASSIMPORT
#endif


#if defined(WIN32) && !defined(MISYSTEMDLL) && !defined(NODLLLINKAGE)
#pragma warning(disable:4231)
extern template class CLASSLIBEXPORT MILIST<TEXTRESITEM>;		// Template instantiation
#pragma warning(default:4231)
#endif

//! List of TEXTRESITEMs.
//typedef MILIST<TEXTRESITEM> TEXTRESITEMLIST;

class CLASSLIBEXPORT TEXTRESITEMLIST : public MILIST<TEXTRESITEM> {};

#undef	CLASSLIBEXPORT

#endif	// INC_MI32_TEXTRESITEMLIST_H
